<template>
  <div class="app-container">
    <div class="network-card">
      <h3>네트워크 디바이스</h3>
      <div class="chart-row">
        <div v-for="device in deviceCategories" :key="device.key" class="chart-container">
          <p v-if="getDeviceStatus(device.key).totalCount > 0">
            {{ getDeviceStatus(device.key).goodCount }} /
            {{ getDeviceStatus(device.key).totalCount }}
          </p>
          <p v-else>디바이스 없음</p>
          <!-- 차트가 들어갈 div -->
          <div :ref="device.ref" class="echart" />

          <p>{{ device.label }}</p>
        </div>
      </div>
    </div>
  </div>
</template>
<script>
import * as echarts from 'echarts'

export default {

  name: 'NetworkHealthChart',
  data() {
    return {
      charts: [],
      deviceCategories: [ // 장비 카테고리 및 차트 레퍼런스
        { key: 'Router', ref: 'chartRouter', label: '라우터' },
        { key: 'Core', ref: 'chartCore', label: '핵심' },
        { key: 'Distribute', ref: 'chartDistribute', label: '배포' },
        { key: 'Access', ref: 'chartAccess', label: '액세스' },
        { key: 'WirelessController', ref: 'chartWirelessController', label: '무선 컨트롤러' },
        { key: 'AccessPoint', ref: 'chartAccessPoint', label: '엑세스 포인트' }
        // 다른 카테고리 추가...
      ]
    }
  },
  computed: {
    dnacToken() {
      return this.$store.getters.dnacToken
    },
    healthDistribution() {
      return this.$store.getters['dnaCenter/healthDistribution']
    }
  },

  created() {
    this.fetchData()
  },
  beforeDestroy() {
    this.charts.forEach(chart => {
      if (chart) {
        chart.dispose()
      }
    })
  },
  methods: {
    initCharts() {
      this.$nextTick(() => {
        this.deviceCategories.forEach(device => {
          console.log(`Ref: ${device.ref}`, this.$refs[device.ref]) // 차트 참조가 정의되었는지 확인
          const chartRef = this.$refs[device.ref]
          if (chartRef && chartRef[0]) {
            const chartInstance = echarts.init(chartRef[0])
            const option = this.getChartOption(device.key)
            chartInstance.setOption(option)
            this.charts.push(chartInstance)
          } else {
            console.error(`차트 컨테이너 (${device.ref})를 찾을 수 없습니다.`)
          }
        })
      })
    },

    // deviceKey를 기반으로 해당 디바이스의 양호한 장비/총 장비 상태를 반환합니다.
    getDeviceStatus(deviceKey) {
      const device = this.healthDistribution.find(d => d.category === deviceKey)
      if (device) {
        return {
          goodCount: device.goodCount,
          totalCount: device.totalCount
        }
      }
      return { goodCount: 0, totalCount: 0 }
    },
    getChartOption(deviceKey) {
      const distribution = this.healthDistribution.find(d => d.category === deviceKey) || this.getEmptyDistribution()
      const totalCount = distribution.totalCount || 0
      const goodCount = distribution.goodCount || 0
      const fairCount = distribution.fairCount || 0
      const badCount = distribution.badCount || 0
      const noHealthCount = distribution.noHealthCount || 0
      const totalBar = totalCount - (goodCount + fairCount + badCount + noHealthCount)

      return {
        tooltip: {
          trigger: 'item',
          axisPointer: { type: 'shadow' },
          extraCssText: 'padding: 10px; margin-bottom: -30px;', // 여백 조정
          formatter: function(params) {
            let tooltipData = ''
            tooltipData += `<span style='display:inline-block;margin-right:4px;border-radius:10px;width:10px;height:10px;background-color:green;'></span>양호: ${goodCount || 0}<br>`
            tooltipData += `<span style='display:inline-block;margin-right:4px;border-radius:10px;width:10px;height:10px;background-color:blue;'></span>보통: ${fairCount || 0}<br>`
            tooltipData += `<span style='display:inline-block;margin-right:4px;border-radius:10px;width:10px;height:10px;background-color:red;'></span>나쁨: ${badCount || 0}<br>`
            tooltipData += `<span style='display:inline-block;margin-right:4px;border-radius:10px;width:10px;height:10px;background-color:grey;'></span>데이터 없음: ${noHealthCount || 0}<br>`
            return tooltipData
          }
        },
        xAxis: {
          type: 'category',
          data: [deviceKey],
          axisLine: { show: false },
          axisTick: { show: false },
          axisLabel: { show: false }
        },
        yAxis: {
          type: 'value',
          show: false
        },
        grid: {
          backgroundColor: 'rgba(255, 255, 0, 0.8)' // 적용되지 않음
        },
        series: [
          {
            name: '나쁨',
            type: 'bar',
            data: [badCount],
            itemStyle: { color: 'red' },
            stack: 'total'
          },
          {
            name: '보통',
            type: 'bar',
            data: [fairCount],
            itemStyle: { color: 'blue' },
            stack: 'total'
          },
          {
            name: '데이터 없음',
            type: 'bar',
            data: [noHealthCount],
            itemStyle: { color: 'grey' },
            stack: 'total'
          },
          {
            name: '양호',
            type: 'bar',
            data: [goodCount],
            itemStyle: { color: 'green' },
            stack: 'total'
          },
          {
            name: '전체',
            type: 'bar',
            stack: 'total',
            itemStyle: {
              color: 'rgba(200, 200, 200, 0.5)', // 투명도 조절
              barBorderColor: 'rgba(0, 0, 0, 0)' // 테두리 없음
            },
            data: [totalBar]
          }
        ]
      }
    },

    getEmptyDistribution() {
      return { goodPercentage: 0, fairPercentage: 0, badPercentage: 0, noHealthPercentage: 0 }
    },
    async fetchData() {
      // 'fetchNetworkHealth' 액션을 기다립니다.
      await this.$store.dispatch('dnaCenter/fetchNetworkHealth')
      // 데이터 로딩이 완료된 후 차트 초기화를 실행합니다.
      this.$nextTick(() => {
        this.initCharts()
      })
    }

  }
}
</script>

<style>
/* .network-card {
  border: 1px solid #eee;
  padding: 16px;
  margin-bottom: 20px;
} */

.chart-row {
  display: flex;
  justify-content: space-around;
}

.chart-container {
  width: 150px; /* 차트 너비 조절 */
  text-align: center;
}

.chart-container div {
  height: 150px; /* 차트 높이 조절 */
}
</style>
